Page MenuHomePhabricator

Fix failure to record `pullerPHID` in repository pull logs
ClosedPublic

Authored by epriestley on Jan 23 2018, 12:09 AM.
Tags
None
Referenced Files
F13477512: D18912.diff
Fri, Jul 19, 1:16 AM
F13466022: D18912.id45341.diff
Tue, Jul 16, 6:39 AM
F13459859: D18912.diff
Mon, Jul 15, 10:12 AM
F13434771: D18912.id45341.diff
Thu, Jul 11, 12:31 AM
F13434443: D18912.id45373.diff
Wed, Jul 10, 10:20 PM
F13429441: D18912.diff
Wed, Jul 10, 3:33 AM
F13296902: D18912.diff
Jun 6 2024, 9:37 PM
F13283004: D18912.diff
Jun 2 2024, 12:42 PM
Subscribers
None

Details

Summary

See PHI305. Ref T13046.

The SSH workflows currently extend PhabricatorManagementWorkflow to benefit from sharing all the standard argument parsing code. Sharing the parsing code is good, but it also means they inherit a getViewer() method which returns the ommnipotent viewer.

This is appropriate for everything else which extends ManagementWorkflow (like bin/storage, bin/auth, etc.) but not appropriate for SSH workflows, which have a real user.

This caused a bug with the pull logs where pullerPHID was not recorded properly. We used $this->getViewer()->getPHID() but the correct code was $this->getUser()->getPHID().

To harden this against future mistakes:

  • Don't extend ManagementWorkflow. Extend PhutilArgumentWorkflow instead. We only want the argument parsing code.
  • Rename get/setUser() to get/setSSHUser() to make them explicit.

Then, fix the pull log bug by calling getSSHUser() instead of getViewer().

Test Plan
  • Pulled and pushed to a repository over SSH.
  • Grepped all the SSH stuff for the altered symbols.
  • Saw pulls record a valid pullerPHID in the pull log.
  • Used echo {} | ssh ... conduit conduit.ping to test conduit over SSH.

Diff Detail

Repository
rP Phabricator
Lint
Lint Not Applicable
Unit
Tests Not Applicable

Event Timeline

src/applications/diffusion/ssh/DiffusionSSHWorkflow.php
268

This is the actual bugfix.

I also grepped for anything else calling getViewer(), since it would probably indicate another bug, but it looks like this was the only one.

This revision is now accepted and ready to land.Jan 23 2018, 8:52 PM
This revision was automatically updated to reflect the committed changes.